#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "config.h"
#include "mswordview.h"

extern FILE *erroroutput;
extern FILE *outputfile;

extern long int cp;
extern long int realcp;

/*this finds the beginning of a bookmark given a particular cp, adds
the beginning tag and returns the next bookmark cp*/

U32 decode_b_bookmark(textportions *portions)
	{
	int i=0,j;
	U16 *letter;
	while (i<portions->bookmark_b_no)
		{
		if (portions->bookmark_b_cps[i] == cp)
			{
			fprintf(outputfile,"<a name=\"");
			letter = portions->bookmarks.chars[i];
			while (*letter != '\0')
				fprintf(outputfile,"%c",*letter++);
			fprintf(outputfile,"\">");
			if (i == portions->bookmark_b_no-1)
				return(-1);
			else
				return(portions->bookmark_b_cps[i+1]);
			}
		i++;
		}
	if ((portions->bookmark_b_no) > 0)
		return(portions->bookmark_b_cps[0]);
		
	return(-1);
	}

U32 decode_e_bookmark(textportions *portions)
	{
	int i=0,j;
	U16 *letter;
	while (i<portions->bookmark_e_no)
		{
		if (portions->bookmark_e_cps[i] == cp)
			{
			fprintf(outputfile,"</A>");
			if (i == portions->bookmark_e_no-1)
				return(-1);
			else
				return(portions->bookmark_e_cps[i+1]);
			}
		i++;
		}
	if ((portions->bookmark_e_no) > 0)
		return(portions->bookmark_e_cps[0]);
		
	return(-1);
	}

/*this sucks in the bookmark names which will be used for internal hyperlink jumps*/
/*i must remember to free up this memory again*/
void decode_bookmarks(FILE *mainfd,FILE *tablefd,textportions *portions)
	{
	U32 fcSttbfbkmk,lcbSttbfbkmk;
	U32 fcPlcfbkf,lcbPlcfbkf;
	U32 fcPlcfbkl,lcbPlcfbkl;
	int len=0;
	int i,j;
	U16 temp;
	U16 charlen;

	portions->bookmark_b_no=0;
	portions->bookmark_b_cps=NULL;
	portions->bookmark_b_bkfs=NULL;
	portions->bookmark_e_no=0;
	portions->bookmark_e_cps=NULL;
	portions->bookmarks.extra_bytes=NULL;
	portions->bookmarks.chars = NULL;


	fseek(mainfd,0x0142,SEEK_SET);
	fcSttbfbkmk = read_32ubit(mainfd);
	lcbSttbfbkmk = read_32ubit(mainfd);

	error(erroroutput,"table offset for boomarks is %x %d\n",fcSttbfbkmk,lcbSttbfbkmk);

	if (lcbSttbfbkmk>0)
		{
		fseek(tablefd,fcSttbfbkmk,SEEK_SET);
		temp = read_16ubit(tablefd);
		if (temp == 0xFFFF)
			{
			portions->bookmarks.exflag = temp;
			portions->bookmarks.no_of_strings = read_16ubit(tablefd);
			}
		else
			{
			portions->bookmarks.exflag =0;
			portions->bookmarks.no_of_strings = temp;
			}
		portions->bookmarks.extra_byte_flag = read_16ubit(tablefd);
		error(erroroutput,"there are %d strings\n",portions->bookmarks.no_of_strings);

		portions->bookmarks.chars = (U16 **) malloc(portions->bookmarks.no_of_strings*sizeof(U16*));
		portions->bookmarks.extra_bytes = (U8 **) malloc (portions->bookmarks.no_of_strings*sizeof(U8*));
		if ((portions->bookmarks.chars == NULL) || (portions->bookmarks.extra_bytes == NULL))
			{
			fprintf(erroroutput,"mem problem in bookmarks\n");
			exit(-1);
			}

		for (i=0;i<portions->bookmarks.no_of_strings;i++)
			{
			if (portions->bookmarks.extra_byte_flag != 0)
				{
				portions->bookmarks.extra_bytes[i] = malloc(portions->bookmarks.extra_byte_flag * sizeof(U8));
				if (portions->bookmarks.extra_bytes[i] == NULL)
					{
					fprintf(erroroutput,"mem problem in bookmarks\n");
					exit(-1);
					}
				}
			else
				portions->bookmarks.extra_bytes[i]=NULL;

			if (portions->bookmarks.exflag)
				{
				charlen = read_16ubit(tablefd);
				error(erroroutput,"got to here 1, charlen is %d\n",charlen);
				portions->bookmarks.chars[i] = (U16*) malloc((charlen +1) * sizeof(U16));

				if (portions->bookmarks.chars[i] == NULL)
					{
					fprintf(erroroutput,"mem problem in bookmarks\n");
					exit(-1);
					}

				for (j=0;j<charlen;j++)
					portions->bookmarks.chars[i][j] = read_16ubit(tablefd);
				}
			else
				{
				error(erroroutput,"got to here 2\n");
				charlen = getc(tablefd);
				portions->bookmarks.chars[i] = (U16*) malloc((charlen +1) * sizeof(U16));

				if (portions->bookmarks.chars[i] == NULL)
					{
					fprintf(erroroutput,"mem problem in bookmarks\n");
					exit(-1);
					}
				for (j=0;j<charlen;j++)
					portions->bookmarks.chars[i][j] = getc(tablefd);
				}

			portions->bookmarks.chars[i][j] = '\0';
			for(j=0;j<portions->bookmarks.extra_byte_flag;j++)
				portions->bookmarks.extra_bytes[i][j] = getc(tablefd);
			}
		}


	/*part deux*/
	fcPlcfbkf=read_32ubit(mainfd);
	lcbPlcfbkf=read_32ubit(mainfd);
	if (lcbPlcfbkf > 0)
		{
		portions->bookmark_b_no = (lcbPlcfbkf-4)/8;
		portions->bookmark_b_cps = (U32 *) malloc ((portions->bookmark_b_no+1) * sizeof(U32));
		portions->bookmark_b_bkfs = (BKF *) malloc (portions->bookmark_b_no * sizeof(BKF));

		if ((portions->bookmark_b_bkfs==NULL) || (portions->bookmark_b_cps ==NULL))
			{
			fprintf(erroroutput,"arrch, no mem for bookmarks\n");
			exit(-1);
			}

		fseek(tablefd,fcPlcfbkf,SEEK_SET);
		for (i=0;i<portions->bookmark_b_no+1;i++)
			{
			portions->bookmark_b_cps[i] = read_32ubit(tablefd);
			error(erroroutput,"the bookmark b cp is %x\n",portions->bookmark_b_cps[i]);
			}
		for (i=0;i<portions->bookmark_b_no;i++)
			{
			portions->bookmark_b_bkfs[i].ibkl = read_16ubit(tablefd);
			portions->bookmark_b_bkfs[i].flags = read_16ubit(tablefd);
			}
		}

	fcPlcfbkl=read_32ubit(mainfd);
	lcbPlcfbkl=read_32ubit(mainfd);
	if (lcbPlcfbkl> 0)
		{
		portions->bookmark_e_no = (lcbPlcfbkl-4)/4;
		portions->bookmark_e_cps = (U32 *) malloc ((portions->bookmark_e_no+1) * sizeof(U32));

		if (portions->bookmark_e_cps ==NULL)
			{
			fprintf(erroroutput,"arrch, no mem for bookmarks\n");
			exit(-1);
			}

		fseek(tablefd,fcPlcfbkl,SEEK_SET);
		for (i=0;i<portions->bookmark_e_no+1;i++)
			{
			portions->bookmark_e_cps[i] = read_32ubit(tablefd);
			error(erroroutput,"the bookmark e cp is %x\n",portions->bookmark_b_cps[i]);
			}
		}
	}

/*
this attempts to parse the HYPERLINK field that ms uses to encode
hyperlink information
*/

U16 *decode_hyperlink(int letter, long int *swallowcp1, long int *swallowcp2, U16 **deleteme)
	{
	/* a little state machine then */
	/* 
	1) a hyperlink may or may not start with a space, 
	2) then a word HYPERLINK, though sometimes in another language i believe, 
	3) then another space, 
	4) after this usually theres a link 
	5) followed by an optional final space and an optional 0x01
	but 4 might start with a space then \l then a space then a string then a
	space.
	--
	so we need to get the full len of what we're dealing with, read it all in
	then strip out the HYPERLINK portion, scan for a " \l ", remove it, also
	remove any "0x01" and output the remainder.

	as this eats the 0x14 we have to manually do the > in the calling function.
	*/

	/*if these are zero initialize them from the input*/
	static long int from=-1;
	static long to=-1;
	static int no;
	static U16 *array;
	U16 *begin,*begin2;
	static int state;
	int i;

	error(erroroutput,"incoming, letter is %c %x\n",letter,letter);

	if (from == -1)
		{
		from = *swallowcp1;
		to = *swallowcp2;
		array = (U16 *) malloc (sizeof(U16) * ((to+1)-from));
		if (array==NULL)
			{
			error(erroroutput,"no mem for hyperlink\n");
			exit(-1);
			}
		}

	switch(state)
		{
		case 0:
			state=1;
			break;
		case 1:	
			if (letter == 0x20)
				state=2;
			break;
		case 2:
			if (letter != 0x01)
				array[no++] = letter;
			else 
				{
				state=3;
				if (letter != 0x14)
					break;	
				else
					no--;
				}
			/*let 0x14 fall into the next state*/
		case 3:	
			if ((letter == 0x14) || (letter == 0x15))
				{
				state=0;
				no--;
				if (array[no] == ' ')
					no--;
				array[no+1] = '\0';
				/*
				error(erroroutput,"the current string is <!--%s-->\n",array);
				*/
				begin = array;
				/*analyse this string looking for a backslash l, which for now
				we will assume is always found as a space a blackslask an l and a space*/
				if (array[0] == ' ') 
					if (array[1] == '\\')
						if (array[2] == 'l')
							if (array[3] == ' ')
								{
								begin = array+3;
								if (array[4] == '\"')
									{
									*begin='\"';
									*(begin+1)='#';
									}
								else
									*begin='#';
								}
				error(erroroutput,"the current string is <!--");
				begin2 = begin;
				while (*begin2 != '\0')
					error(erroroutput,"%c",*begin2++);
				error(erroroutput,"-->\n");
					
				from=-1;
				to=-1;
				no=0;
				*deleteme = array;
				return(begin);
				}
			break;	
		}

	return(NULL);
	}

/*
this attempts to parse the REF field that ms uses to encode
crosslink information
*/
U16 *decode_crosslink(int letter,long int *swallowcp1, long int *swallowcp2)
	{
	/* a little state machine then */
	/* 
	1) a reference may or may not start with a space, 
	2) then a word PAGEREF, though ill not assume this
	3) then another space
	4) after this theres the name of the bookmark
	5) followed by a space 
	6) there may be a few flags here e.g [\h] [\p] followed by 
	a space.
	7) probably terminating 0x01
	--
	so we need to get the full len of what we're dealing with, read it all in
	then strip out the HYPERLINK portion, scan for a " \l ", remove it, also
	remove any "0x01" and output the remainder.

	as this eats the 0x14 we have to manually do the > in the calling function.
	*/

	static int no=0;
	static int state;
	int i;
	static long int from=-1;
	static long int to=-1;
	static U16 *array;

	if (from == -1)
		{
		from = *swallowcp1;
		to = *swallowcp2;
		error(erroroutput,"a mallocing %d\n",(to+1)-from);
		array = (U16 *) malloc (sizeof(U16) * ((to+1)-from));
		if (array==NULL)
			{
			error(erroroutput,"no mem for hyperlink\n");
			exit(-1);
			}
		}

	switch(state)
		{
		case 0:
			state=1;
			break;
		case 1:
			if (letter == 0x20) 
				state=2;
			break;
		case 2:
			if ((letter != 0x20) && (letter != 0x01) && (letter != 0x14))
				array[no++] = letter;
			else 
				{
				state=0;
				from=-1;
				to=-1;
				array[no] = '\0';
				no=0;
				return(array);
				}
			break;
		}
	return(NULL);
	}
